#include "ClausesDriver.h"

using namespace std;

ClausesDriver::ClausesDriver(const std::string &f)
	: trace_scanning (false), trace_parsing (false) 
{
        filename = f;
}

ClausesDriver::~ClausesDriver()
{
    delete pdb;
    delete vng;
}

void ClausesDriver::parse (const std::string &f) 
{ 
	file = f; 
	scan_begin (); 
	yy::ClausesParser parser (*this); 
	parser.set_debug_level (trace_parsing); 
	parser.parse (); 
	scan_end ();
}

void ClausesDriver::error (const yy::location& l, const std::string& m) 
{ 
	std::cerr << l << ": " << m << std::endl; 
} 
void ClausesDriver::error (const std::string& m) 
{ 
	std::cerr << m << std::endl; 
} 

void ClausesDriver::execute()
{
        parse(filename);
}

InputSet *ClausesDriver::getInputSet()
{
        return new InputSet(result);
}
