#ifndef B_DEDUCTIONENGINE_H_
#define B_DEDUCTIONENGINE_H_

#include "DeductionEngine.h"
#include "ATPException.h"
#include "Refinement.h"
#include "ResolvingUnit.h"
#include "Resolvent.h"
#include "ResolventPostProcessor.h"
#include "ProofProcess.h"
#include <time.h>

class BinaryDeductionEngine : public DeductionEngine
{
public:
	BinaryDeductionEngine();
	virtual ~BinaryDeductionEngine();

	//TODO enumerate resolvents if empty resolvent is not reached
	Resolvent* deduce(Clause *target);
private:
	std::list<Resolvent *> executeBFS(ProofEnvironment *env, Clause *c1, Clause *c2, ClauseStrategy *cs);
	void postProcess(Resolvent *r);
	bool isTargetResolvent(Resolvent *r, Clause *c);
};

#endif /*B_DEDUCTIONENGINE_H_*/
