#ifndef CERESXMLNODEPRINT_H_INCLUDED
#define CERESXMLNODEPRINT_H_INCLUDED

#include "NodePrint.h"

#include <fstream>
#include <iostream>
#include <string>
#include <map>

#include "Variable.h"
#include "Term.h"
#include "Clause.h"
#include "Unifier.h"
#include "Resolvent.h"
#include "ParaModulant.h"
#include "ConcreteClause.h"
#include "ProofEnvironment.h"

class CEResXMLNodePrint : public NodePrint
{
    std::ofstream ofs;
    ProofEnvironment *env;
public:
    CEResXMLNodePrint(ProofEnvironment *env);
    ~CEResXMLNodePrint();
    void initialize();
    void finalize();
    void printNode(Variant&);
    void printNode(Resolvent&);
    void printNode(ParaModulant&);
    void printNode(Clause&);
    void printNode(Unifier&);
    void printNode(Factor&);
    void beginNode(ProofNode&);
    void endNode(ProofNode&);
    void beginChildren(ProofNode&);
    void endChildren(ProofNode&);
    void beginTree();
    void endTree();

    private:
    void printSequent(Clause &c);
    void printFormula(NS_PROOFLIB::Term*, ClauseContext *);
    void printTerm(NS_PROOFLIB::Term*, ClauseContext *);
    Variant *getVariant(ProofNode&);
};

#endif // CERESXMLNODEPRINT_H_INCLUDED
