//
// File:   ClauseStrategy.h
// Author: tomina
//
// Created on 25 November 2007, 01:08
//

#ifndef _CLAUSESTRATEGY_H
#define	_CLAUSESTRATEGY_H

#include "InformativeProofNode.h"
#include "ClauseStrategyRuling.h"
#include "Clause.h"


/*
 *Must be monotonic, if something was not allowed, any later strategy
 *must not allow this as well it may not allow other things.
 *Otherwise the Refinement + Strategy will not be complete.
 */
class ClauseStrategy : public InformativeProofNode
{
public:
	virtual ~ClauseStrategy() {}
    virtual ClauseStrategyRuling *getRuling(Clause *c1, Clause *c2, int ind1, int ind2, bool pos1, bool pos2) = 0;
};


// default implementation
class SimpleStrategy : public ClauseStrategy
{
	ClauseStrategyRuling *getRuling(Clause *c1, Clause *c2, int ind1, int ind2, bool pos1, bool pos2)
	{
		ClauseStrategyRuling *ret = new ClauseStrategyRuling(ind1, ind2, pos1, pos2);
		return ret;
	}
};
#endif	/* _CLAUSESTRATEGY_H */

