/*
 * =====================================================================================
 *
 *       Filename:  ClausesInput.h
 *
 *    Description:  interface for reading the clauses set
 *
 *        Version:  1.0
 *        Created:  03/11/08 14:44:27
 *       Revision:  none
 *       Compiler:  gcc
 *
 *         Author:  Tomer Libal (tl), shaolin@logic.at
 *        Company:  E185/2
 *
 * =====================================================================================
 */

#ifndef  clausesinput_INC
#define  clausesinput_INC

class InputSet;

#include        "InputSet.h"

class ClausesInput
{
    public:
        /* ====================  LIFECYCLE     ======================================= */
        ClausesInput () {}                             /* constructor */
        virtual ~ClausesInput() {}

        /* ====================  OPERATORS     ======================================= */
        virtual InputSet *parseFromFile(const std::string& f) = 0;
        virtual InputSet *parseFromString(std::string& s) = 0;

}; /* -----  end of class  ClausesInput  ----- */

#endif   /* ----- #ifndef clausesinput_INC  ----- */
