#ifndef DEDUCTIONENGINE_H_
#define DEDUCTIONENGINE_H_

#include "ATPException.h"
#include "ProofEnvironment.h"
#include "Resolvent.h"

class ProofProcess;

/* reports user compatibility between dynamic parts of the system exceptions
 */
class CompatibilityException : public ATPException
{
public :
	CompatibilityException(const std::string msg) : ATPException(msg) {}
};

class Resolvent;

class DeductionEngine
{
protected:
	ProofEnvironment *env;

public:
	DeductionEngine();
	virtual ~DeductionEngine();

	virtual Resolvent* deduce(Clause *target) = 0;
	void setEnvironment(ProofEnvironment *);
};

#endif /*DEDUCTIONENGINE_H_*/
