#include "InputSet.h"

using namespace std;

InputSet::InputSet(std::set<Clause *> *cst)
{
    if (cst == NULL) 
    {
        throw InputException("Input set cannot be empty");
    }
    clauseSet = cst;
    
    //clean all clauses contexts
    typedef set<Clause *>::const_iterator CCI;
    for (CCI it = clauseSet->begin(); it != clauseSet->end(); ++it)
    {
    	Clause *c = *it;
    	c->getClauseContext()->clear();
    }
}

InputSet::~InputSet()
{
    // TODO delete clauses and proof tree, right now because we recursively delete
    // the proof tree we get segmentation fault when trying to delete the clauses
    // that should initiate the deletion of the tree
	// delete all terms and clauses
        /*for (set<Clause*>::const_iterator it = clauseSet->begin(); it != clauseSet->end(); ++it)
        {
            Clause *c = *it;
            // delete terms only when deleting the terms database
            for (vector<Term*>::const_iterator poit = c->getPositiveLiterals()->begin(); poit != c->getPositiveLiterals()->end(); ++poit)
            {
                (*poit)->detach();
            }
            for (vector<Term*>::const_iterator poit = c->getNegativeLiterals()->begin(); poit != c->getNegativeLiterals()->end(); ++poit)
            {
                (*poit)->detach();
            }
            delete c;
        }
	delete clauseSet;*/
}

bool InputSet::isEmpty()
{
	return clauseSet->empty();
}

std::set<Clause *> *InputSet::getClauseSet()
{
    return clauseSet;
}

void InputSet::insert(Clause *c)
{
	clauseSet->insert(c);
}

string InputSet::toString()
{
	string ret = "{";
	for (set<Clause*>::const_iterator it = clauseSet->begin(); it != clauseSet->end(); ++it)
	{
		Clause *c = *it;
		ret.append(c->toString());
	}
	ret.append("}");
	return ret;
}

set<Clause*> InputSet::searchForClauses(string &t)
{
	set<Clause*> ret;
	
	for (set<Clause*>::const_iterator it = clauseSet->begin(); it != clauseSet->end(); ++it)
	{
		Clause *cls = *it;
		if (cls->toString().find(t) != string::npos)
		{
			ret.insert(cls);
		}
	}
	
	return ret;
}