#ifndef INTERACTIVEREFINEMENT_H_
#define INTERACTIVEREFINEMENT_H_

#include "Refinement.h"
#include "ManagedRefinement.h"
#include "UserCommand.h"
#include "ProofEnvironment.h"
#include "ProofProcess.h"


class InteractiveRefinement : public Refinement
{
private:
	ProofEnvironment *env;
	UserCommand *ucom;
	int autoSteps;
	InputSet *is;

public:
	InteractiveRefinement(ProofEnvironment *e);
	virtual ~InteractiveRefinement();
	void setUserCommand(UserCommand *uc);
	virtual void initialize(InputSet *cs);
	virtual void finalize();
	virtual bool isEmpty() const;
	virtual ResolvingSequence *getNextResolvingSequence();
	virtual void setEventPerformed(InputSetEvent);

};

#endif /*INTERACTIVEREFINEMENT_H_*/
