//
// File:   LatexNodePrint.h
// Author: shaolin
//
// Created on March 15, 2008, 9:12 PM
//

#ifndef _LATEXNODEPRINT_H
#define	_LATEXNODEPRINT_H

#include "NodePrint.h"

#include <fstream>
#include <iostream>
#include <string>
#include <map>

#include "Variable.h"
#include "Term.h"
#include "Clause.h"
#include "Unifier.h"
#include "Resolvent.h"
#include "ParaModulant.h"
#include "ConcreteClause.h"
#include "ProofEnvironment.h"

class LatexNodePrint : public NodePrint
{
	ProofEnvironment *env;
    std::ofstream ofs;
public:
    LatexNodePrint(ProofEnvironment *env);
    ~LatexNodePrint();
    void initialize();
    void finalize();
    void printNode(Variant&);
    void printNode(Resolvent&);
    void printNode(ParaModulant&);
    void printNode(Clause&);
    void printNode(Unifier&);
    void printNode(Factor&);
    void beginNode(ProofNode&);
    void endNode(ProofNode&);
    void beginChildren(ProofNode&);
    void endChildren(ProofNode&);
    void beginTree();
    void endTree();
};

#endif	/* _LATEXNODEPRINT_H */

