/*
 * File:   ProofNode.h
 * Author: tomina
 *
 * Created on 25 November 2007, 00:59
 */

#ifndef _PROOFNODE_H
#define	_PROOFNODE_H

#include "NodePrint.h"
#include <vector>
#include <set>
#include <string>
#include <typeinfo>

class ProofNode
{
protected:
    std::vector<ProofNode*> *parents;
    std::vector<ProofNode*> *children;

public:
    ProofNode();
    virtual ~ProofNode();
    void addParent(ProofNode*);
    virtual void print(NodePrint&);
    bool hasParents();
	std::vector<ProofNode*> *getChildren();
	
protected:
	virtual std::string toString();
	std::set<ProofNode*> getParentsOfType(const std::type_info &ti);
	std::set<ProofNode*> getChildrenOfType(const std::type_info &ti);

private:
    void addChild(ProofNode*);
};


#endif	/* _PROOFNODE_H */

