/*
 * ProofProcess.cpp
 *
 *  Created on: 30-Oct-2008
 *      Author: shaolin
 */

#include "ProofProcess.h"

using namespace std;

ProofProcess::ProofProcess(ProofEnvironment *e) {
	env = e;

}

ProofProcess::~ProofProcess() {
	// TODO Auto-generated destructor stub
}


ProofEnvironment *ProofProcess::getEnvironment()
{
	return env;
}


// Main methods

void ProofProcess::initialize(InputSet *cs)
{
	totalElapsedTime = time (NULL);

	if (cs == 0 || cs->isEmpty())
	{
			throw new InputException("Input set is empty");
	}

	env->getRefinement()->initialize(cs);
	env->getDeductionEngine()->setEnvironment(env);
	// sometimes the set is not empty but the refinement is
	// such as when unit refinement get a set with no unit clause
	if (env->getRefinement()->isEmpty())
	{
		throw new InputException("Refinement is empty");
	}
}

InputSet *ProofProcess::getInputSet()
{
	return is;
}

// the two methods using the engine are thread safe but both are using different refinements, so they should not work in parallel but can be executed in parallel
// (I.E one can be called from within the other so they will be sequential)
Resolvent *ProofProcess::execute()
{
	// execute engine as long as
	Resolvent *ret = env->getDeductionEngine()->deduce(NULL);
}

Resolvent *ProofProcess::isDeducibleFrom(std::set<Clause*> *s, Clause *c)
{

}

int ProofProcess::getElapsedTime()
{
    return time(NULL) - totalElapsedTime;
}

int ProofProcess::getMachineTime()
{
    return getElapsedTime() - env->getRefinement()->getUserTime();
}
