/*
 * ProofProcess.h
 *
 *  Created on: 30-Oct-2008
 *      Author: shaolin
 */

#ifndef PROOFPROCESS_H_
#define PROOFPROCESS_H_

#include "ATPException.h"
#include "ProofEnvironment.h"
#include "ClausesInput.h"
#include "Resolvent.h"
#include "InputSet.h"
#include "Refinement.h"

class ProofEnvironment;
class InputSet;
class ClausesInput;

class ProofProcess {

private:

    InputSet *is;
    ClausesInput *clausesInput;
    ProofEnvironment *env;
	int totalElapsedTime;

public:
	ProofProcess(ProofEnvironment *env);
	virtual ~ProofProcess();

	ProofEnvironment *getEnvironment();
	void initialize(InputSet *cs);
	Resolvent *execute();
	Resolvent *isDeducibleFrom(std::set<Clause*>*, Clause *); // check if c is deducible from s, return the resulted resolvent if there is or null.

	InputSet *getInputSet();
    int getElapsedTime();
    int getMachineTime();
};

#endif /* PROOFPROCESS_H_ */
