#ifndef REFINEMENT_H_
#define REFINEMENT_H_

#include "InputSet.h"
#include "ResolvingSequence.h"
#include "ATPException.h"
#include "InputSetEvent.h"
#include "InputSetEventListener.h"
#include <string>
#include <time.h>

class RefinementException : public ATPException
{
public :
	RefinementException(const std::string msg) : ATPException(msg) {}
};

class Refinement : public InputSetEventListener
{
protected:
	int userTime;

public:
	Refinement() {	userTime = 0;}
	virtual ~Refinement() {}
	virtual void initialize(InputSet *cs) = 0;
	virtual void finalize() = 0;
	virtual bool isEmpty() const = 0;
	// here despite isEmpty, deduction engine checks also for null
	// in this case, please make sure the next round isEmpty will return true
	// (otherwise there will be an infinite loop)
	virtual ResolvingSequence *getNextResolvingSequence() = 0;
	int getUserTime();
};

#endif /*REFINEMENT_H_*/
