#include "Resolvent.h"

using namespace std;

Resolvent::Resolvent(std::vector<NS_PROOFLIB::Term *> pos, std::vector<NS_PROOFLIB::Term *> neg, type t, VariableNameGenerator *vng) : ConcreteClause(pos, neg, vng)
{
	resType = t;
}

Resolvent::~Resolvent()
{
}

Resolvent::type Resolvent::getType() const
{
	return resType;
}

void Resolvent::setClauseContext(Unifier *u)
{
	Clause::setClauseContext(u);
	addParent(u);
}

void Resolvent::print(NodePrint& printer)
{
    printer.beginNode(*this);
    printer.printNode(*this);
    printer.beginChildren(*this);
    for (vector<ProofNode*>::const_iterator it = parents->begin(); it != parents->end();++it)
    {
        (*it)->print(printer);
    }
    printer.endChildren(*this);
    printer.endNode(*this);
}
