#ifndef RESOLVENTPOSTPROCESSOR_H_
#define RESOLVENTPOSTPROCESSOR_H_

#include "Resolvent.h"
#include "InputSet.h"
#include "Refinement.h"
#include "InputSetEventListener.h"

class ResolventPostProcessor
{
public:
	ResolventPostProcessor();
	virtual ~ResolventPostProcessor();
	// return true if post processing should continue or false otherwise
	virtual bool postProcess(Resolvent *r) = 0;
	void addInputSetEventListener(InputSetEventListener *);
	virtual void init(InputSet *s){}
	int priority;
protected:
	std::list<InputSetEventListener*> listeners;
	void fireEventPerformed(InputSetEvent);
};

class PostProcessorPriorityCmp
{
public:
	bool operator()(const ResolventPostProcessor*, const ResolventPostProcessor*) const;
};

#endif /*RESOLVENTPOSTPROCESSOR_H_*/
