#include "ResolvingSequence.h"

using namespace std;
using namespace NS_PROOFLIB;

ResolvingSequence::ResolvingSequence(ClauseStrategy *s) : InformativeProofNode()
{
    strategy = s;
    index = 0;
}

ResolvingSequence::~ResolvingSequence()
{
    delete strategy;
}

void ResolvingSequence::initialize(std::vector<Clause*> &l)
{
	//TODO enable a flag to determine if should check if should use variants
	bool useVariants = false;
	if (hasSharedVariables(l))
	{
		useVariants = true;
	}
    for (std::vector<Clause*>::const_iterator iter = l.begin(); iter != l.end(); ++iter)
    {
    	Clause *c;
    	if (useVariants) c = (*iter)->getVariant();
    	else c = (*iter);
    	seq.push_back(c);
        //addParent(c);
    }
    //strategy->addParent(this);
}

// check if they have shared variables, also in the context
// meaning the shared variable is already mapped to a closed term
// but we still wish to rename it in order as not to replace the whole term
bool ResolvingSequence::hasSharedVariables(const vector<Clause*> &seq)
{
	set<Variable*> vars;
	Variable *v;
	for (vector<Clause*>::const_iterator it = seq.begin(); it != seq.end();++it)
	{
		set<Variable*> variables = (*it)->getAllVariables();
		//TODO improve set intersection
		for (set<Variable*>::const_iterator it2 = variables.begin(); it2 != variables.end(); ++it2)
		{
			v = *it2;
			// the variable was already in the set (from some other clause)
			if (!vars.insert(v).second)
			{
				return true;
			}
		}
	}
	return false;
}

bool ResolvingSequence::isEmpty() const
{
	return seq.size() >= index;
}

Clause *ResolvingSequence::getNextClause()
{
    Clause *c = seq.at(index++);
    return c;
}	

int ResolvingSequence::getSize() const
{
	return seq.size();
}

ClauseStrategy *ResolvingSequence::getClauseStrategy()
{
     return strategy;
}
