#ifndef RESOLVINGSEQUENCE_H_
#define RESOLVINGSEQUENCE_H_

#include "Clause.h"
#include "Resolvent.h"
#include "InformativeProofNode.h"
#include "ClauseStrategy.h"

#include <vector>

class ResolvingSequence : public InformativeProofNode
{
    std::vector<Clause *> seq;
    ClauseStrategy *strategy;
    unsigned int index;
    
public:
	ResolvingSequence(ClauseStrategy *s);
	virtual ~ResolvingSequence();
    void initialize(std::vector<Clause*> &seq);
	bool isEmpty() const;
	int getSize() const;
	Clause* getNextClause();
    ClauseStrategy *getClauseStrategy();
    
private:
	bool hasSharedVariables(const std::vector<Clause*> &seq);
};

#endif /*RESOLVINGSEQUENCE_H_*/
