#ifndef RESOLVINGUNIT_H_
#define RESOLVINGUNIT_H_

#include "Resolvent.h"
#include "Clause.h"
#include "ClauseStrategyRuling.h"
#include "ATPException.h"
#include "ClauseStrategy.h"

#include <string>
#include <set>

class Unifier;

class ResolvingException : public ATPException
{
public :
	ResolvingException(const std::string msg) : ATPException(msg) {}
};

class ResolvingUnit
{
public:
	ResolvingUnit();
	virtual ~ResolvingUnit();
	/*
	 * should resolve the two clauses on the two literals using also factorization
	 * which should be optimized for the literals checked
	 */
	virtual std::set<Resolvent*, ClausePointerCmp> resolve(Clause *c1, Clause *c2, ClauseStrategyRuling *s) = 0;

};

#endif /*RESOLVINGUNIT_H_*/
