#ifndef SIMPLEREFINEMENT_H_
#define SIMPLEREFINEMENT_H_

#include "ManagedRefinement.h"
#include <vector>
#include "ClauseStrategy.h"

#include <map>
#include <string>
#include <vector>

/*
 *Brut force refinement, creates a pair for each possible pair of clauses and
 *order them
 */
class SimpleRefinement : public ManagedRefinement
{
    std::vector<std::pair<Clause*, Clause*>*> ds;
    int index;
    std::vector<Clause*> curInputSet;
    InputSet *cs;
    
public:
	SimpleRefinement();
	~SimpleRefinement();
	void initialize(InputSet *cs);
	void finalize();
	bool isEmpty() const;
	ResolvingSequence *getNextResolvingSequence();
	void setEventPerformed(InputSetEvent ise);

	std::map<Clause*, int> getIndicesMap();
	std::string getIndicesMessage();
	ResolvingSequence *getResolvingSequenceFromIndices(std::vector<int>);

private:
    void deletePreviousData();
};

#endif /*SIMPLEREFINEMENT_H_*/
