#include "TautologyEliminationPostProcessor.h"

using namespace std;
using namespace NS_PROOFLIB;

TautologyEliminationPostProcessor::TautologyEliminationPostProcessor()
{
}

TautologyEliminationPostProcessor::~TautologyEliminationPostProcessor()
{
}

bool TautologyEliminationPostProcessor::postProcess(Resolvent *r)
{
	vector<Term*> pos = r->getPositiveLiterals();
	vector<Term*> neg = r->getNegativeLiterals();
		
	typedef std::vector<Term*>::const_iterator LI;
	ClauseContext *cc = r->getClauseContext();
	
	// inserts string rep of all terms of negative side
	set<string> negstr;
	for (LI it = neg.begin(); it != neg.end(); ++it)
	{
		negstr.insert(cc->getStringValueInContext(*it));
	}
	
	// iterate on all positive and check if they are contained in set
	for (LI it = pos.begin(); it != pos.end(); ++it)
	{
		if (negstr.find(cc->getStringValueInContext(*it)) != negstr.end())
		{
			// found a tautological pair of literals
			string msg;
			msg.append(r->toString());
			msg.append(" was rejected as it is a tautology\n");
			fireEventPerformed(InputSetEvent(InputSetEvent::CLAUSE_REFUSED, r, msg));
			return false;
		}
	}
	
	return true;
}