#include "Unifier.h"

using namespace std;
using namespace NS_PROOFLIB;

Unifier::Unifier()
{
}

Unifier::Unifier(Unifier &u)
:ClauseContext(u)
{
	status = u.status;
}

Unifier::~Unifier()
{
}

void Unifier::merge(ClauseContext *cc)
{
	typedef map<Variable*, Term*>::const_iterator MI;
	for (MI it = cc->contextMap.begin(); it != cc->contextMap.end(); ++it)
	{
		pair<Variable*, Term*> p = (*it);
		Variable *v = p.first;
		Term *b = p.second;
		if (contextMap.count(v) == 0)
		{
			mapVariableToTerm(v, b);
		}
	}
}

Unifier::Status Unifier::getStatus()
{
	return status;
}

string Unifier::getStatusString()
{
	switch (getStatus())
	{
		case Unifier::OK:
			return "OK";
		case Unifier::OccurCheck:
			return "OccurCheck";
		case Unifier::SymbolClash:
			return "SymbolClash";
	}
	return "Unknown";
}

void Unifier::setStatus(Unifier::Status s)
{
	status = s;
}

void Unifier::initialize(ClauseContext *cc1, ClauseContext *cc2)
{
	typedef map<Variable*, Term*>::const_iterator MI;
	for (MI it = cc1->contextMap.begin(); it != cc1->contextMap.end(); ++it)
	{
		pair<Variable*, Term*> p = *it;
		mapVariableToTerm(p.first, p.second);
	}
	for (MI it = cc2->contextMap.begin(); it != cc2->contextMap.end(); ++it)
	{
		pair<Variable*, Term*> p = *it;
		mapVariableToTerm(p.first, p.second);
	}
}
void Unifier::initialize(ClauseContext *cc)
{
	typedef map<Variable*, Term*>::const_iterator MI;
	for (MI it = cc->contextMap.begin(); it != cc->contextMap.end(); ++it)
	{
		pair<Variable*, Term*> p = *it;
		mapVariableToTerm(p.first, p.second);
	}
}

string Unifier::toString()
{
	string ret;
	ret.append(ClauseContext::toString());
	return ret;
}

void Unifier::print(NodePrint& printer)
{
    printer.beginNode(*this);
    printer.printNode(*this);
    printer.beginChildren(*this);
    for (vector<ProofNode*>::const_iterator it = parents->begin(); it != parents->end();++it)
    {
        (*it)->print(printer);
    }
    printer.endChildren(*this);
    printer.endNode(*this);
}