#ifndef USERCOMMAND_H_
#define USERCOMMAND_H_

#include "DeductionEngine.h"
#include "Resolvent.h"
#include "ClausesInput.h"
#include "NodePrint.h"
#include "ProofEnvironment.h"
#include "ProofProcess.h"
#include "UserReply.h"

#include <map>
#include <vector>
#include <string>

class UserCommand
{
protected:
	ProofEnvironment *env;
	ProofProcess *process;

public:
	UserCommand();
	virtual ~UserCommand();
	virtual void execute() = 0;
	virtual UserReply *getReplyFromUser(InputSet *is, std::map<Clause*, int>, std::string) = 0;
	virtual void errorEncountered(std::string msg) = 0;
	virtual void clausesEventPerformed(InputSetEvent&) = 0;
	void setEnvironment(ProofEnvironment *env);
};
#endif /*USERCOMMAND_H_*/
