#ifndef PROMPTUSERCOMMAND_H_
#define PROMPTUSERCOMMAND_H_

#include "UserCommand.h"
#include "Resolvent.h"
#include "DeductionEngine.h"
#include "MacroStepRefinement.h"
#include <vector>
#include <map>
#include <string>
#include <sstream>

template <class T>
bool from_string(T& t,
                 const std::string& s,
                 std::ios_base& (*f)(std::ios_base&))
{
  std::istringstream iss(s);
  return !(iss >> f >> t).fail();
}

class PromptUserCommand : public UserCommand
{
public:
	PromptUserCommand();
	virtual ~PromptUserCommand();
	void execute();
	UserReply *getReplyFromUser(InputSet *is, std::map<Clause*, int>, std::string);
	void errorEncountered(std::string msg) ;
	void clausesEventPerformed(InputSetEvent &r);

private:
	std::vector<int> printInfo(std::map<Clause*, int> m);
	UserReply *retrieveInfo(InputSet *is, std::map<Clause*, int> m, std::string s, std::vector<int>&);
	int indexToLocation(int index, std::vector<int> &mappedIndices);
};

// comparison used for printing on screen
struct printComp {
  bool operator() (const std::pair<Clause*,int>& lhs, const std::pair<Clause*,int>& rhs) const
  {return lhs.second<rhs.second;}
};


#endif /*PROMPTUSERCOMMAND_H_*/
