#ifndef __SETUPPARSER_H
#define __SETUPPARSER_H

#include "DeductionEngine.h"
#include "BinaryDeductionEngine.h"
#include "SimpleRefinement.h"
#include "UnitRefinement.h"
#include "UnificationResolver.h"
#include "ManagedRefinement.h"
#include "ResolvingUnit.h"
#include "SimpleVariableNameGenerator.h"
#include "SimpleInsertPostProcessor.h"
#include "TautologyEliminationPostProcessor.h"
#include "ForwardSubsumptionPostProcessor.h"
#include "StillmanSubsumptionAlgorithm.h"
#include "PromptUserCommand.h"
#include "InteractiveRefinement.h"
//#include "ClausesDriver.h"
#include "SpiritParser.h"
#include "datatypes.h"
#include "LatexNodePrint.h"
#include "CEResXMLNodePrint.h"
#include "Factorizer.h"
#include "ResolvedLiteralFactorizer.h"
#include "NoFactorizer.h"
#include "SimpleUnificationAlgorithm.h"
#include "SimpleParaModulator.h"
#include "BFSParaModulator.h"
#include "NoParaModulator.h"
#include "PositiveRefinement.h"
#include "ExtendedProofEnvironment.h"

#include <libxml++/libxml++.h>

class SetupParser : public xmlpp::SaxParser
{

public:
    UserCommand *userCommand;
    ExtendedProofEnvironment *env;

  SetupParser();
  virtual ~SetupParser();

protected:
  //overrides:
  virtual void on_start_document();
  virtual void on_end_document();
  virtual void on_start_element(const Glib::ustring& name,
                                const AttributeList& properties);
  virtual void on_end_element(const Glib::ustring& name);
  virtual void on_characters(const Glib::ustring& characters);
  virtual void on_comment(const Glib::ustring& text);
  virtual void on_warning(const Glib::ustring& text);
  virtual void on_error(const Glib::ustring& text);
  virtual void on_fatal_error(const Glib::ustring& text);
};
#endif // __SETUPPARSER_H
