#include <fstream>
#include <iostream>

#include "SetupParser.h"

int
main(int argc, char* argv[])
{
  Glib::ustring filepath;
  filepath = "setup.xml";
  UserCommand *ucom;

  SpiritProofEnvironmentExtension *env;

  // Parse the entire document in one go:
   try
   {
     SetupParser parser;
     parser.set_substitute_entities(true);
     parser.parse_file(filepath);
     ucom = parser.userCommand;
     env = parser.env;
   }
   catch(const xmlpp::exception& ex)
   {
     std::cout << "libxml++ exception: " << ex.what() << std::endl;
   }

  	/*SpiritParser *parser = new SpiritParser(env);
  	//std::string s = "d.";
  	std::string s = " p(f(x,f(y,x))).  p(f(f(x,f(y,z)),f(f(x,y),f(x,z)))). -p(x) | -p(f(x,y)) | p(y). -p(f(a,a)).";
    InputSet *set = parser->parseFromString(s);
    cout<<set->toString()<<endl;

      return 0;
*/


  try
  {
      ucom->execute();
  }
  catch (ATPException *e)
  {
      std::cerr<<"Exception in main: "<<e->getMessage()<<std::endl;
  }
  delete ucom;
}
