#include "Prover9Driver.h"

using namespace std;

Prover9Driver::Prover9Driver(Prover9ProofEnvironmentExtension *e)
	: trace_scanning (false), trace_parsing (false)
{
        env = e;
}

Prover9Driver::~Prover9Driver()
{
    delete pdb;
}

void Prover9Driver::parse (const std::string &f)
{
	file = f;
	scan_begin ();
	yy::ClausesParser parser (*this);
	parser.set_debug_level (trace_parsing);
	parser.parse ();
	scan_end ();
}

void Prover9Driver::error (const yy::location& l, const std::string& m)
{
	std::cerr << l << ": " << m << std::endl;
}
void Prover9Driver::error (const std::string& m)
{
	std::cerr << m << std::endl;
}

void Prover9Driver::execute()
{
        parse(env->getInputFilename());
}

InputSet *Prover9Driver::getInputSet()
{
        return new InputSet(result);
}
