#ifndef PROVER9PARSER_H_
#define PROVER9PARSER_H_

#include <string>
#include "y.tab.h"
#include "Clause.h"
#include "ClausesInput.h"
#include "InputSet.h"
#include <set>
#include "Prover9ProofEnvironmentExtension.h"

// Announce to Flex the prototype we want for lexing function, ...
# define YY_DECL \
yy::ClausesParser::token_type \
yylex (yy::ClausesParser::semantic_type* yylval, \
yy::ClausesParser::location_type* yylloc, \
Prover9Driver& driver)
// ... and declare it for the parsers sake.
YY_DECL;

class Prover9Driver : public ClausesInput
{

public:
	Prover9ProofEnvironmentExtension *env;
	Prover9Driver(Prover9ProofEnvironmentExtension *env);
	virtual ~Prover9Driver();

        void execute();
        InputSet *getInputSet();

	NS_PROOFLIB::ProofDatabase *pdb;
	VariableNameGenerator *vng;
	std::set<Clause*> *result;
	// Handling the scanner.
	void scan_begin ();
	void scan_end ();
	bool trace_scanning;

	// Handling the parser.
	void parse (const std::string& f);
	std::string file;
	bool trace_parsing;

	// Error handling.
	void error (const yy::location& l, const std::string& m);
	void error (const std::string& m);

};

#endif /*PROVER9PARSER_H_*/
