/*
 * Result.cpp
 *
 *  Created on: 06-Nov-2008
 *      Author: shaolin
 */

#include "Result.h"

using namespace std;

Result::Result(SpiritProofEnvironmentExtension *e) {
	env = e;
	literal_vector = new std::pair<std::vector<NS_PROOFLIB::Term*>, std::vector<NS_PROOFLIB::Term*> >(std::vector<NS_PROOFLIB::Term*>(),std::vector<NS_PROOFLIB::Term*>());
	clause_set = new std::set<Clause*>();
}

Result::~Result() {

}

void Result::insertClause()
{
	clause_set->insert(clause);
	cout<<clause->toString()<<endl;
}

void Result::createClause()
{
	clause = new Clause(literal_vector->first, literal_vector->second, env->getVariableNameGenerator());
	clause->setClauseContext(new ClauseContext());
	literal_vector = new std::pair<std::vector<NS_PROOFLIB::Term*>, std::vector<NS_PROOFLIB::Term*> >(std::vector<NS_PROOFLIB::Term*>(),std::vector<NS_PROOFLIB::Term*>());
}

void Result::insertLiteral(bool pos)
{
	if (pos)
	{
		literal_vector->first.push_back(term);
	}
	else
	{
		literal_vector->second.push_back(term);
	}
}

void Result::createFunctionName(std::string &x)
{
	//cout<<"f: "<<x<<endl;
	stack.push(new std::string(x));
	map[stack.top()] = new NS_PROOFLIB::TermList();
}

void Result::createVariable(std::string &x)
{
	//cout<<"v: "<<x<<endl;
	term = env->getProofDatabase()->newVariable(x.c_str());
	delete map[stack.top()];
	map.erase(stack.top());
	delete stack.top();
	stack.pop();
}

void Result::createConstant(std::string &x)
{
	//cout<<"c: "<<x<<endl;
	term = env->getProofDatabase()->newConstant(x.c_str());
}

void Result::createFunction()
{
	//cout<<"cf: "<<*(stack.top())<<endl;
	std::string x = *stack.top();
	term = env->getProofDatabase()->newFunction(stack.top()->c_str(), *(map[stack.top()]) );
	map.erase(stack.top());
	delete stack.top();
	stack.pop();
}

void Result::addTerm()
{
	//cout<<"at: "<<*(stack.top())<<endl;
	map[stack.top()]->addRight(term);
}

std::set<Clause*> *Result::getClausesSet()
{
	return clause_set;
}
