/*
 * Result.h
 *
 *  Created on: 06-Nov-2008
 *      Author: shaolin
 */

#ifndef RESULT_H_
#define RESULT_H_

#include "Term.h"
#include "Constant.h"
#include "Function.h"
#include "Variable.h"
#include "datatypes.h"
#include "Clause.h"
#include "ConcreteClause.h"
#include "VariableNameGenerator.h"
#include "ClauseContext.h"
#include "SpiritProofEnvironmentExtension.h"

#include <string>
#include <vector>
#include <set>
#include <stack>
#include <map>

class Result {
private:
	NS_PROOFLIB::Term *term;
	std::string *sval;
	Clause *clause;
	std::pair<std::vector<NS_PROOFLIB::Term*>, std::vector<NS_PROOFLIB::Term*> > *literal_vector;
	std::set<Clause*> *clause_set;
	SpiritProofEnvironmentExtension *env;
	std::stack<std::string*> stack;
	std::map<std::string*, NS_PROOFLIB::TermList *> map;

public:
	Result(SpiritProofEnvironmentExtension *e);
	virtual ~Result();
	void insertClause();
	void createClause();
	void insertLiteral(bool pos);
	void createFunctionName(std::string &x);
	void createVariable(std::string &x);
	void createConstant(std::string &x);
	void createFunction();
	void addTerm();
	std::set<Clause*> *getClausesSet();
};

#endif /* RESULT_H_ */
