/*
 * SpiritParser.cpp
 *
 *  Created on: 05-Nov-2008
 *      Author: shaolin
 */

#include "SpiritParser.h"

using namespace std;

SpiritParser::SpiritParser(SpiritProofEnvironmentExtension *e) {
	env = e;

}

SpiritParser::~SpiritParser() {
	// TODO Auto-generated destructor stub
}

InputSet *SpiritParser::parseFromFile(const std::string& f)
{
	file_iterator<> first(f);

	if (!first)
	{
	   // error cannot read file
		return NULL;
	}

	file_iterator<> last = first.make_end();

	Result result(env);
	Prover9Grammer grammer(result);

	if (parse(first, last, grammer, space_p).full)
	{
		return new InputSet(result.getClausesSet());
	}
	else
	{
		return NULL;
	}
}
InputSet *SpiritParser::parseFromString(std::string& str)
{
	Result result(env);
	Prover9Grammer grammer(result);

	if (parse(str.c_str(), grammer, space_p).full)
	{
		return new InputSet(result.getClausesSet());
	}
	else
	{
		return NULL;
	}
}
