#ifndef BFSPARAMODULATOR_H_
#define BFSPARAMODULATOR_H_

#include "ParaModulator.h"
#include "ResolvingUnit.h"
#include "ParaModulant.h"

class BFSParaModulator : public ParaModulator
{
public:
	BFSParaModulator();
	virtual ~BFSParaModulator();
	
	std::set<ParaModulant*> modulate(Clause *c1, Clause *c2, int index1, bool isPos1, int index2, bool isPos2);
		
	private:
		std::set<std::pair<Unifier*, NS_PROOFLIB::Term*> > extractModulant(NS_PROOFLIB::Term *s1, NS_PROOFLIB::Term *s2, NS_PROOFLIB::Term *t2, ClauseContext *cc1, ClauseContext *cc2, NS_PROOFLIB::ProofDatabase *pdb);
		std::set<std::pair<Unifier*, NS_PROOFLIB::Term*> > recExtractModulant(NS_PROOFLIB::Term *s1, NS_PROOFLIB::Term *s2, NS_PROOFLIB::Term *t2, ClauseContext *cc1, ClauseContext *cc2, NS_PROOFLIB::ProofDatabase *pdb);
		ParaModulant *buildModulant(Clause *c1, Clause *c2, Unifier *unifier, NS_PROOFLIB::Term *t, int index1, bool isPos1, int index2, bool isPos2);
};

#endif /*BFSPARAMODULATOR_H_*/
