#ifndef RESOLVEDLITERALFACTORIZER_H_INCLUDED
#define RESOLVEDLITERALFACTORIZER_H_INCLUDED

#include "Factorizer.h"
#include "UnifierImp.h"
#include "ConcreteClause.h"

class ResolvedLiteralFactorizer : public Factorizer
{
    public:
    ResolvedLiteralFactorizer();
    ~ResolvedLiteralFactorizer();
	/* factors are ordered by smaller (with regard to number of terms) are first
	 * as if this is not true we may have an infinite circle such as:
	 * {{p(X), p(Y)},{}} {{},{p(X), p(Y)}} and we get for the same elements as factors
	 * {{p(X)},{p(Y)}} and when resolving again we get back both original terms
	 * TODO: handle duplication of the same literals, right now only different ones
	 * are factored
	 */
	std::set<std::pair<Clause*, unsigned int>, ClausePairCmp> getFactorsSet(Clause *c, ClauseContext *, unsigned int ind, bool indPos);

	private:
	std::set<std::pair<Clause*, unsigned int>, ClausePairCmp> getRecFactorsSet(Clause *c, ClauseContext *, Clause *gparent, unsigned int ind, bool indPos);
};

#endif // RESOLVEDLITERALFACTORIZER_H_INCLUDED
