#ifndef SIMPLEPARAMODULATOR_H_
#define SIMPLEPARAMODULATOR_H_

#include "ParaModulator.h"
#include "ResolvingUnit.h"
#include "ParaModulant.h"

class SimpleParaModulator : public ParaModulator
{
public:
	SimpleParaModulator();
	virtual ~SimpleParaModulator();
	std::set<ParaModulant*> modulate(Clause *c1, Clause *c2, int index1, bool isPos1, int index2, bool isPos2);
	
private:
	std::pair<Unifier*, NS_PROOFLIB::Term*> extractModulant(NS_PROOFLIB::Term *s1, NS_PROOFLIB::Term *s2, NS_PROOFLIB::Term *t2, ClauseContext *cc1, ClauseContext *cc2, NS_PROOFLIB::ProofDatabase *pdb);
	std::pair<Unifier*, NS_PROOFLIB::Term*> recExtractModulant(NS_PROOFLIB::Term *s1, NS_PROOFLIB::Term *s2, NS_PROOFLIB::Term *t2, ClauseContext *cc1, ClauseContext *cc2, NS_PROOFLIB::ProofDatabase *pdb);
	ParaModulant *buildModulant(Clause *c1, Clause *c2, Unifier *unifier, NS_PROOFLIB::Term *t, int index1, bool isPos1, int index2, bool isPos2);
};

#endif /*SIMPLEPARAMODULATOR_H_*/
