#include "SimpleUnificationAlgorithm.h"

using namespace std;
using namespace NS_PROOFLIB;

Unifier *SimpleUnificationAlgorithm::getUnifiers(Clause *c1, Clause *c2, int indL1, bool isPos1, int indL2, bool isPos2)
{

	Term *t1;
	Term *t2;

	vector<Term*> pos1 = c1->getPositiveLiterals();
	vector<Term*> pos2 = c2->getPositiveLiterals();

	vector<Term*> neg1 = c1->getNegativeLiterals();
	vector<Term*> neg2 = c2->getNegativeLiterals();

    if (isPos1)
    {
        t1 = pos1.at(indL1);
    }
    else
    {
        t1 = neg1.at(indL1);
    }

    if (isPos2)
    {
        t2 = pos2.at(indL2);
    }
    else
    {
        t2 = neg2.at(indL2);
    }

    Unifier *unifier = unify(t1, t2, c1->getClauseContext(), c2->getClauseContext());

	return unifier;
}

Unifier *SimpleUnificationAlgorithm::unify(Term *t1, Term *t2, ClauseContext *c)
{
	Unifier *unifier = new UnifierImp();
	unifier->initialize(c);
	unifier->unify(t1, t2);
	return unifier;
}
Unifier *SimpleUnificationAlgorithm::unify(Term *t1, Term *t2, ClauseContext *cc1, ClauseContext *cc2)
{
	Unifier *unifier = new UnifierImp();
	unifier->initialize(cc1, cc2);
	unifier->unify(t1, t2);
	return unifier;
}
