#ifndef UNIFICATIONRESOLVER_H_
#define UNIFICATIONRESOLVER_H_

#include "ResolvingUnit.h"
#include "Resolvent.h"
#include "Clause.h"
#include "Term.h"
#include "ClauseStrategyRuling.h"
#include "UnifierImp.h"
#include "Factorizer.h"
#include "UnificationAlgorithm.h"
#include "ParaModulator.h"
#include "UnificationProofEnvironmentExtension.h"

#include <vector>
#include <list>
#include <set>

class UnificationResolver : public ResolvingUnit
{
    UnificationProofEnvironmentExtension *env;

public:
	UnificationResolver(UnificationProofEnvironmentExtension *e);
	~UnificationResolver();
	/*
	 * factorization is being done only on literals that can be unified, i.e. first
	 * unify and if success continue the process on all the possible factors as well
	 */
	std::set<Resolvent*, ClausePointerCmp> resolve(Clause *c1, Clause *c2, ClauseStrategyRuling *s);
private:
	std::pair<std::vector<NS_PROOFLIB::Term*>, std::vector<NS_PROOFLIB::Term*> > buildLiterals(bool, int indL1, int indL2, std::vector<NS_PROOFLIB::Term*> &pos1, std::vector<NS_PROOFLIB::Term*> &neg1, std::vector<NS_PROOFLIB::Term*> &pos2, std::vector<NS_PROOFLIB::Term*> &neg2);
};
#endif /*UNIFICATIONRESOLVER_H_*/
