#ifndef FORWARDSUBSUMPTIONPOSTPROCESSOR_H_
#define FORWARDSUBSUMPTIONPOSTPROCESSOR_H_

#include "ResolventPostProcessor.h"
#include <set>
#include "InputSet.h"
#include "ClauseFeatureVectorIndex.h"
#include "SubsumptionAlgorithm.h"

class ForwardSubsumptionPostProcessor : public ResolventPostProcessor, public InputSetEventListener
{
	ClauseFeatureVectorIndex index;
	SubsumptionAlgorithm *alg;
public:
	ForwardSubsumptionPostProcessor();
	virtual ~ForwardSubsumptionPostProcessor();
	virtual bool postProcess(Resolvent *r);
	void init(InputSet *is);
	void setEventPerformed(InputSetEvent ise);
	void setSubsumptionAlgorithm(SubsumptionAlgorithm *a);
private:
	bool isSubsumed(Clause *subsumed, Clause *subsumer);
};

#endif /*FORWARDSUBSUMPTIONPOSTPROCESSOR_H_*/
